%define	tclvers	        8.0.5
%define tclXvers	8.0.4
%define	expvers	        5.28
%define	Tixvers		4.1.0
%define	itclvers	3.0.1

Summary: A Tcl/Tk development environment: tcl, tk, tix, tclX, expect, and itcl
Name: tcltk
Version: %{tclvers}
Release: 19mdk
Source0: ftp://ftp.scriptics.com/pub/tcl/tcl8_0/tcl%{tclvers}.tar.bz2
Source1: ftp://ftp.scriptics.com/pub/tcl/tcl8_0/tk%{tclvers}.tar.bz2
Source2: ftp://ftp.cme.nist.gov/pub/expect/expect.tar.bz2
Source3: ftp://ftp.neosoft.com/pub/tcl/TclX/tclX%{tclXvers}.tar.bz2
Source4: ftp://ftp.xpi.com/pub/ioi/Tix%{Tixvers}.006.tar.bz2
Source5: ftp://ftp.tcltk.com/pub/itcl/itcl%{itclvers}.tar.bz2
Patch0: tcltk-8.0-ieee.patch.bz2
Patch1: tcl8.0.3-glibc21.patch.bz2
Patch2: expect-5.24-mkpasswd.patch.bz2
Patch3: expect-5.26-alpha.patch.bz2
Patch4: expect-5.26-glibc21.patch.bz2
Patch5: expect-5.28-jbj.patch.bz2
Patch7: tix-4.1.0.6-perf.patch.bz2
Patch8: tclX-8.0.4-jbj.patch.bz2
Copyright: BSD
Group: System/Libraries
Buildroot: /var/tmp/%{name}-root

%description
Tcl is a simple scripting language designed to be embedded into
other applications.  Tcl is designed to be used with Tk, a widget
set, which is provided in the tk package.  This package also includes
tclsh, a simple example of a Tcl application.

%package -n tcl
#Version: 8.0.3
Summary: An embeddable scripting language.
Group: System/Libraries
URL: http://www.scriptics.com

%description -n tcl
Tcl is a simple scripting language designed to be embedded into
other applications.  Tcl is designed to be used with Tk, a widget
set, which is provided in the tk package.  This package also includes
tclsh, a simple example of a Tcl application.

If you're installing the tcl package and you want to use Tcl for
development, you should also install the tk and tclx packages.

%package -n tk
#Version: 8.0.3
Summary: Tk GUI toolkit for Tcl, with shared libraries
Group: System/Libraries
URL: http://www.scriptics.com

%description -n tk
Tk is a X Windows widget set designed to work closely with the tcl
scripting language. It allows you to write simple programs with full
featured GUI's in only a little more time then it takes to write a
text based interface. Tcl/Tk applications can also be run on Windows
and Macintosh platforms.

%package -n expect
Version: %{expvers}
Summary: A tcl extension for simplifying program-script interaction.
Group: System/Libraries

%description -n expect
Expect is a tcl extension for automating interactive applications such
as telnet, ftp, passwd, fsck, rlogin, tip, etc.  Expect is also useful
for testing the named applications.  Expect makes it easy for a script
to control another program and interact with it.

Install the expect package if you'd like to develop scripts which interact
with interactive applications.  You'll also need to install the tcl
package.

%package -n tclx
#Version: %{tclXvers}
Summary: Tcl/Tk extensions for POSIX systems.
Group: System/Libraries
URL: http://www.neosoft.com/

%description -n tclx
TclX is a set of extensions which make it easier to use the Tcl
scripting language for common UNIX/Linux programming tasks.  TclX
enhances Tcl support for files, network access, debugging, math, lists,
and message catalogs.  TclX can be used with both Tcl and Tcl/Tk
applications.

Install TclX if you are developing applications with Tcl/Tk.  You'll
also need to install the tcl and tk packages.

%package -n tix
Version: %{Tixvers}.6
Summary: A set of capable widgets for Tk.
Group: System/Libraries

%description -n tix
Tix (Tk Interface Extension), an add-on for the Tk widget set, is an
extensive set of over 40 widgets.  In general, Tix widgets are more
complex and more capable than the widgets provided in Tk.  Tix widgets
include a ComboBox, a Motif-style FileSelectBox, an MS Windows-style
FileSelectBox, a PanedWindow, a NoteBook, a hierarchical list, a
directory tree and a file manager.

Install the tix package if you want to try out more complicated widgets
for Tk.  You'll also need to have the tcl and tk packages installed.

%package -n itcl
Version: %{itclvers}
Summary: object oriented mega widgets for tcl
Group: System/Libraries

%description -n itcl
[incr Tcl] is an object-oriented extension of the Tcl language.  It
was created to support more structured programming in Tcl.  Tcl scripts
that grow beyond a few thousand lines become extremely difficult to
maintain.  This is because the building blocks of vanilla Tcl are
procedures and global variables, and all of these building blocks
must reside in a single global namespace.  There is no support for
protection or encapsulation.

[incr Tcl] introduces the notion of objects.  Each object is a bag
of data with a set of procedures or "methods" that are used to
manipulate it.  Objects are organized into "classes" with identical
characteristics, and classes can inherit functionality from one
another.  This object-oriented paradigm adds another level of
organization on top of the basic variable/procedure elements, and
the resulting code is easier to understand and maintain.

%prep

%setup -q -c -a 1 -a 2 -a 3 -a 4 -a 5

cd tcl%{tclvers}
#%patch0 -p2 -b .ieee
%patch1 -p2 -b .glibc21
cd ..

cd expect-%{expvers}
%patch2 -p2 -b .mkpasswd
%patch3 -p2 -b .alpha
%patch4 -p2 -b .glibc21
%patch5 -p2 -b .jbj
cd ..

# no patch 6

cd Tix%{Tixvers}
%patch7 -p2 -b .perf
cd ..

cd tclX%{tclXvers}
%patch8 -p2 -b .wrongtclXvers
cd ..

# XXX this was only needed with the IEEE patch0
#cd tcl%{tclvers}/unix
#autoconf
#cd ../../
#cd tk%{tclvers}/unix
#autoconf

#==========================================
%build

# make the libraries reentrant
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -D_REENTRANT"

#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared --enable-gcc

%configure --enable-shared --enable-gcc
make
cd ../..

#------------------------------------------
# Tk
#
cd tk%{tclvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared --enable-gcc

%configure --enable-shared --enable-gcc
make CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT"
cd ../..

#------------------------------------------
# tclX
#
cd tclX%{tclXvers}/unix
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --enable-shared

%configure --enable-shared --enable-gcc
make CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT"
cd ../..

#------------------------------------------
# Expect
#
cd expect-%{expvers}
#libtoolize --copy --force
#CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \

%configure --enable-shared --enable-gcc --with-tclconfig=../tcl%{tclvers}/unix --with-tkconfig=../tk%{tclvers}/unix --with-tclinclude=../tcl%{tclvers}/generic --with-tkinclude=../tk%{tclvers}/generic

# XXX drill out HAVE_OPENPTY for now
perl -pi -e 's,#define HAVE_OPENPTY 1,/* #undef HAVE_OPENPTY */,' expect_cf.h || :
# XXX drill in HAVE_PTMX for now
perl -pi -e 's,/* #undef HAVE_PTMX */,#define HAVE_PTMX 1' expect_cf.h || :

make CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT"

cd ..

#------------------------------------------
# Tix
#
cd Tix%{Tixvers}/unix
#libtoolize --copy --force
#./configure --prefix=/usr --disable-cdemos --enable-shared

%configure --enable-shared --enable-gcc --disable-cdemos

cd tk8.0
#libtoolize --copy --force
#./configure --prefix=/usr --disable-cdemos --enable-shared \
#	--with-tcl=../../../tcl%{tclvers} --with-tk=../../../tk%{tclvers}

%configure --enable-shared --enable-gcc --disable-cdemos --with-tcl=../../../tcl%{tclvers} --with-tk=../../../tk%{tclvers}
make
cd ../../..

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
#libtoolize --copy --force
#./configure --prefix=/usr --enable-shared

%configure --enable-shared --exec-prefix=/foo --enable-gcc
make CFLAGS="$RPM_OPT_FLAGS -D_REENTRANT"
cd ..

#==========================================
%install

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr

for i in tcl tk tclx expect tix itcl; do
  echo '%defattr(-,root,root)' > $i.files
done


#------------------------------------------
# Tcl
#
cd tcl%{tclvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtcl8.0.so $RPM_BUILD_ROOT/usr/lib/libtcl.so
ln -sf tclsh8.0 $RPM_BUILD_ROOT/usr/bin/tclsh
cd ../..

find $RPM_BUILD_ROOT/ -type 'f'|grep man | xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | sort >> tcl.files

#------------------------------------------
# Tk
#
cd tk%{tclvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtk8.0.so $RPM_BUILD_ROOT/usr/lib/libtk.so
ln -sf wish8.0 $RPM_BUILD_ROOT/usr/bin/wish
cd ../..

find $RPM_BUILD_ROOT/ -type 'f'|grep man | xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files \
	| sort | uniq -u >> tk.files

#------------------------------------------
# TclX
#
cd tclX%{tclXvers}/unix
make INSTALL_ROOT=$RPM_BUILD_ROOT install
ln -sf libtkx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtkx.so
ln -sf libtclx%{tclXvers}.so $RPM_BUILD_ROOT/usr/lib/libtclx.so
cd ../..

find $RPM_BUILD_ROOT/ -type 'f'|grep man| xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files \
	| sort | uniq -u >> tclx.files

#------------------------------------------
# Expect
#
cd expect-%{expvers}
make prefix=$RPM_BUILD_ROOT/usr install
cd ..

find $RPM_BUILD_ROOT/ -type 'f'|grep -E '.*[0-9]($|x)' | xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files \
	| sort | uniq -u >> expect.files

# for files in expect.files, sed the #! at the top...
for n in `cat expect.files`; do
	if head -1 $n | grep '#!'; then
		cp -a $n $n.in
                chmod +w $n
		sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
	fi
done

#------------------------------------------
# Tix
#
cd Tix%{Tixvers}/unix
LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib make prefix=$RPM_BUILD_ROOT/usr install
cd ../..
mv $RPM_BUILD_ROOT/usr/man/mann/tixwish.1 $RPM_BUILD_ROOT/usr/man/man1/tixwish.1
ln -sf libtix4.1.8.0.so $RPM_BUILD_ROOT/usr/lib/libtix.so

find $RPM_BUILD_ROOT/ -type 'f'|grep /man/ | xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files expect.files\
	| sort | uniq -u >> tix.files

for n in `cat tix.files`; do
        if head -1 $n | grep '#!'; then
                cp -a $n $n.in
                chmod +w $n
                sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
        fi
done

#------------------------------------------
# itcl
#
cd itcl%{itclvers}
make INSTALL_ROOT=$RPM_BUILD_ROOT exec_prefix=/usr install
ln -sf libitk3.0.so $RPM_BUILD_ROOT/usr/lib/libitk.so
ln -sf libitcl3.0.so $RPM_BUILD_ROOT/usr/lib/libitcl.so
cd ..

find $RPM_BUILD_ROOT/ -type 'f'|grep /man/ | xargs file \
	| grep troff | cut -d: -f1 | xargs bzip2 -9f

(find $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/include \
	$RPM_BUILD_ROOT/usr/man -type f -o -type l;
 find $RPM_BUILD_ROOT/usr/lib/*) | cat - tcl.files tk.files tclx.files expect.files tix.files \
	| sort | uniq -u >> itcl.files

for n in `cat itcl.files`; do
        if head -1 $n | grep '#!'; then
                cp -a $n $n.in
                chmod +w $n
                sed "s|$RPM_BUILD_ROOT||" < $n.in > $n
		rm -f $n.in
        fi
done

#------------------------------------------
# strip dynamic libraries
#
find $RPM_BUILD_ROOT -name "*.so*" -type f | xargs strip --remove-section=.comment --remove-section=.note --strip-unneeded

#------------------------------------------
# this is too annoying to watch
set +x
for n in *.files; do
	mv $n $n.in
	sed "s|.*/usr|/usr|" < $n.in | while read file; do
	    if [ -d $RPM_BUILD_ROOT/$file ]; then
		echo -n '%dir '
	    fi
	    echo $file
	done > $n
done
set -x

#Strip the binaries
strip $RPM_BUILD_ROOT/usr/bin/* || :

#==========================================

for i in `find $RPM_BUILD_ROOT/ -type 'f' -perm '+a=x' ! -name 'lib*so*'`; do
	file $i |grep -q "not stripped" && strip $i
done

%post -p /sbin/ldconfig -n tcl
%post -p /sbin/ldconfig -n tk
%post -p /sbin/ldconfig -n expect
%post -p /sbin/ldconfig -n tclx
%post -p /sbin/ldconfig -n tix
%post -p /sbin/ldconfig -n itcl

%postun -p /sbin/ldconfig -n tcl
%postun -p /sbin/ldconfig -n tk
%postun -p /sbin/ldconfig -n expect
%postun -p /sbin/ldconfig -n tclx
%postun -p /sbin/ldconfig -n tix
%postun -p /sbin/ldconfig -n itcl

%clean
rm -rf $RPM_BUILD_ROOT

%files -f tcl.files -n tcl
%files -f tk.files -n tk
%files -f tclx.files -n tclx
%files -f expect.files -n expect
%files -f tix.files -n tix
%files -f itcl.files -n itcl

%changelog
* Wed May 10 2000 Frederic Lepied <flepied@mandrakesoft.com> 8.0.5-19mdk
- fixed tclx broken symlinks.

* Fri Mar 31 2000 Frederic Lepied <flepied@mandrakesoft.com> 8.0.5-18mdk
- fix groups.

* Mon Jan 24 2000 Frederic Lepied <flepied@mandrakesoft.com> 8.0.5-17mdk
- bzipped man pages.
- remove rm -f from previous release to not loose permissions.

* Wed Jan 12 2000 Pixel <pixel@mandrakesoft.com>
- fix build as non-root
- added some rm -f cuz rights pb

* Sun Nov 21 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- bzip2 tixwish manpage.

* Sun Nov 07 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Increase release for compatibility with expect.

* Wed Nov  3 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 8.0.5.

* Wed May 05 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.com>
- Mandrake adaptions
- fix handling of RPM_OPT_FLAGS and reentrance

* Thu Apr  8 1999 Jeff Johnson <jbj@redhat.com>
- use /usr/bin/write in kibitz (#1320).
- use cirrus.sprl.umich.edu in weather (#1926).

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 28)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- whoops, exec-prefix for itcl was set to '/foo', changed to '/usr'.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- expect does unaligned access on alpha (#989)
- upgrade tcl/tk/tclX to 8.0.4
- upgrade expect to 5.28.
- add itcl 3.0.1

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to allow building on the arm
- build for glibc 2.1
- strip binaries

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update tcl/tk/tclX to 8.0.3, expect is updated also.

* Mon Jun 29 1998 Jeff Johnson <jbj@redhat.com>
- expect: mkpasswd needs delay before sending password (problem #576)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed expect binaries exec permissions

* Thu Apr 09 1998 Erik Troan <ewt@redhat.com>
- updated to Tix 4.1.0.006
- updated version numbers of tcl/tk to relflect includsion of p2

* Wed Mar 25 1998 Cristian Gafton <gafton@redhat.com>
- updated tcl/tk to patch level 2
- updated tclX to 8.0.2

* Thu Oct 30 1997 Otto Hammersmith <otto@redhat.com>
- fixed filelist for tix... replacing path to the expect binary in scripts
  was leaving junk files around.

* Wed Oct 22 1997 Otto Hammersmith <otto@redhat.com>
- added patch to remove libieee test in configure.in for tcl and tk.
  Shoudln't be needed anymore for glibc systems, but this isn't the "proper" 
  solution for all systems
- fixed src urls

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>
- removed version numbers from descriptions

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- updated to tcl/tk 8.0 and related versions of packages

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
- fixed dangling tclx/tkx symlinks
